0

1.本地mongo数据库版本

2.服务器mongo版本

3.本地PHP版本

4.服务器php版本

3.同样的版本同样的代码使用aggregate聚合时,本地报错:
127.0.0.1:27017: The 'cursor' option is required, except for aggregation explain
服务器上确一切正常。
4.代码如下:

$this->_m    = new Mongo('mongodb://127.0.0.1:27017');
$db = $this->_m->selectDB("qdgame");
$collection_user = $db->selectCollection("user");   //user表
$option = array(
        array('$match'=>array('_id'=>array('$in'=>$ids))),  //查询条件
        array('$group'=> array('_id'=>null,                 //按字段分组,
            'gold'=>array('$sum'=>'$gold'),                 //求和的字段
            'ruby'=>array('$sum'=>'$ruby'),                  //求和的字段
            'coupon'=>array('$sum'=>'$coupon'))),             //求和的字段
    );
    $users_info = $collection_user->aggregate($option);
    

有哪位大神给指点一下这是什么情况,难道是版本的问题?

查看全部 2 个回答

0

已采纳

问题已解决,是mongodb版本的问题不是php版本的问题,我本地用的是mongo3.5.9,服务器上用的是mongo3.2.7,因为新版本的mongo3.5版本以上都必须加上游标,3.5版本以下的可以不用加游标选项。
aggregate()参数2就是游标选项,下文中batchSize<int>最初的 批量的大小为0.

$this->_m    = new Mongo('mongodb://127.0.0.1:27017');
$db = $this->_m->selectDB("qdgame");
$collection_user = $db->selectCollection("user");   //user表
$option = array(
        array('$match'=>array('_id'=>array('$in'=>$ids))),  //查询条件
        array('$group'=> array('_id'=>null,                 //按字段分组,
            'gold'=>array('$sum'=>'$gold'),                 //求和的字段
            'ruby'=>array('$sum'=>'$ruby'),                  //求和的字段
            'coupon'=>array('$sum'=>'$coupon'))),             //求和的字段
    );
    $users_info = $collection_user->aggregate($option,[ "cursor" => [ "batchSize" => 0 ] ]);